/*
	Copyright (C) 2011 Roger Manuel
	Copyright (C) 2012-2013 DeSmuME team

	This file is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 2 of the License, or
	(at your option) any later version.

	This file is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with the this software.  If not, see <http://www.gnu.org/licenses/>.
*/

#import <Cocoa/Cocoa.h>
#include <libkern/OSAtomic.h>

@class CocoaDSMic;

enum
{
	DSControllerState_Right = 0,
	DSControllerState_Left,
	DSControllerState_Down,
	DSControllerState_Up,
	DSControllerState_Select,
	DSControllerState_Start,
	DSControllerState_B,
	DSControllerState_A,
	DSControllerState_Y,
	DSControllerState_X,
	DSControllerState_L,
	DSControllerState_R,
	DSControllerState_Debug,
	DSControllerState_Lid,
	
	DSControllerState_Touch,
	DSControllerState_Microphone,
	
	DSControllerState_StatesCount
};

@interface CocoaDSController : NSObject
{
	CocoaDSMic *cdsMic;
	NSPoint touchLocation;
	bool controllerState[DSControllerState_StatesCount];
	
	OSSpinLock spinlockControllerState;
}

@property (retain) CocoaDSMic *cdsMic;

- (id) initWithMic:(CocoaDSMic *)theMic;

- (void) setSoundInputMode:(NSInteger)inputMode;
- (void) setControllerState:(BOOL)theState controlID:(NSUInteger)controlID;
- (void) setTouchState:(BOOL)theState location:(NSPoint)theLocation;
- (void) flush;

@end
